OpenVDB: CurvatureStencil< GridT, RealT > Class Template Reference

OpenVDB 10.0.1

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Attributes | Friends | List of all members
CurvatureStencil< GridT, RealT > Class Template Reference

`#include <nanovdb/util/Stencils.h>`

Inherits BaseStencil< CurvatureStencil< GridT >, 19, GridT >.

## Public Types
using | GridType = GridT
using | TreeType = typename GridT::TreeType
using | ValueType = typename GridT::ValueType
using | AccessorType = typename GridT::AccessorType

## Public Member Functions
| CurvatureStencil (const GridType &grid)
| CurvatureStencil (const GridType &grid, double dx)
ValueType | meanCurvature () const
| Return the mean curvature at the previously buffered location. More...
ValueType | gaussianCurvature () const
| Return the Gaussian curvature at the previously buffered location. More...
void | curvatures (ValueType &mean, ValueType &gauss) const
| Return both the mean and the Gaussian curvature at the previously buffered location. More...
ValueType | meanCurvatureNormGrad () const
ValueType | gaussianCurvatureNormGrad () const
void | curvaturesNormGrad (ValueType &mean, ValueType &gauss) const
| Return both the mean and the Gaussian curvature at the previously buffered location. More...
void | principalCurvatures (ValueType &min, ValueType &max) const
| Computes the minimum and maximum principal curvature at the previously buffered location. More...
ValueType | laplacian () const
Vec3< ValueType > | gradient () const
template<int i, int j, int k>
unsigned int | pos () const
| Return linear offset for the specified stencil point relative to its center. More...
void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. More...
void | moveTo (const Coord &ijk, const ValueType &centerValue)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known. More...
void | moveTo (const IterType &iter)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors. More...
void | moveTo (const Vec3< RealType > &xyz)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors. More...
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos. More...
const ValueType & | getValue () const
| Return the value at the specified location relative to the center of the stencil. More...
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil. More...
ValueType | mean () const
| Return the mean value of the current stencil. More...
ValueType | min () const
| Return the smallest value in the stencil buffer. More...
ValueType | max () const
| Return the largest value in the stencil buffer. More...
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil. More...
const ValueType & | getCenterValue () const
| Return the value at the center of the stencil. More...
bool | intersects (const ValueType &isoValue=ValueType(0)) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue. More...
Mask | intersectionMask (ValueType isoValue=ValueType(0)) const
| Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue. More...
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed. More...
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil. More...

## Static Public Member Functions
static int | size ()
| Return the size of the stencil buffer. More...

## Static Public Attributes
static constexpr int | SIZE = 19

## Protected Attributes
const GridType * | mGrid
Coord | mCenter

## Friends
template<typename , int , typename >
class | BaseStencil

## Member Typedef Documentation

## ◆ AccessorType

using AccessorType = typename GridT::AccessorType
| inherited

## ◆ GridType

using GridType = GridT

## ◆ TreeType

using TreeType = typename GridT::TreeType

## ◆ ValueType

using ValueType = typename GridT::ValueType

## Constructor & Destructor Documentation

## ◆ CurvatureStencil() [1/2]

CurvatureStencil | ( | const GridType & | grid | ) |
| inline

## ◆ CurvatureStencil() [2/2]

CurvatureStencil | ( | const GridType & | grid,
|  | double | dx
| ) |  |
| inline

## Member Function Documentation

## ◆ accessor()

const AccessorType & accessor | ( |  | ) | const
| inlineinherited

Return a const reference to the ValueAccessor associated with this Stencil.

## ◆ curvatures()

void curvatures | ( | ValueType & | mean,
|  | ValueType & | gauss
| ) |  | const
| inline

Return both the mean and the Gaussian curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ curvaturesNormGrad()

void curvaturesNormGrad | ( | ValueType & | mean,
|  | ValueType & | gauss
| ) |  | const
| inline

Return both the mean and the Gaussian curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ gaussianCurvature()

ValueType gaussianCurvature | ( |  | ) | const
| inline

Return the Gaussian curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ gaussianCurvatureNormGrad()

ValueType gaussianCurvatureNormGrad | ( |  | ) | const
| inline

Return the mean Gaussian multiplied by the norm of the central-difference gradient.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ getCenterCoord()

const Coord & getCenterCoord | ( |  | ) | const
| inlineinherited

Return the coordinates of the center point of the stencil.

## ◆ getCenterValue()

const ValueType & getCenterValue | ( |  | ) | const
| inlineinherited

Return the value at the center of the stencil.

## ◆ getValue() [1/2]

const ValueType & getValue | ( |  | ) | const
| inlineinherited

Return the value at the specified location relative to the center of the stencil.

## ◆ getValue() [2/2]

const ValueType & getValue | ( | unsigned int | pos = `0` | ) | const
| inlineinherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## ◆ gradient()

Vec3< ValueType > gradient | ( |  | ) | const
| inline

Return the gradient computed at the previously buffered location by second-order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ grid()

const GridType & grid | ( |  | ) | const
| inlineinherited

Return a const reference to the grid from which this stencil was constructed.

## ◆ intersectionMask()

Mask intersectionMask | ( | ValueType | isoValue = `ValueType(0)` | ) | const
| inlineinherited

Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use (mask & (1u<<2)) where mask is ther return value from this function. To check if there are any intersections use mask!=0u, and for no intersections use mask==0u. To count the number of intersections use __builtin_popcount(mask).

## ◆ intersects()

bool intersects | ( | const ValueType & | isoValue = `ValueType(0)` | ) | const
| inlineinherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## ◆ laplacian()

ValueType laplacian | ( |  | ) | const
| inline

Return the Laplacian computed at the previously buffered location by second-order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ max()

ValueType max | ( |  | ) | const
| inlineinherited

Return the largest value in the stencil buffer.

## ◆ mean()

ValueType mean | ( |  | ) | const
| inlineinherited

Return the mean value of the current stencil.

## ◆ meanCurvature()

ValueType meanCurvature | ( |  | ) | const
| inline

Return the mean curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ meanCurvatureNormGrad()

ValueType meanCurvatureNormGrad | ( |  | ) | const
| inline

Return the mean curvature multiplied by the norm of the central-difference gradient. This method is very useful for mean-curvature flow of level sets!

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ min()

ValueType min | ( |  | ) | const
| inlineinherited

Return the smallest value in the stencil buffer.

## ◆ moveTo() [1/4]

void moveTo | ( | const Coord & | ijk | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## ◆ moveTo() [2/4]

void moveTo | ( | const Coord & | ijk,
|  | const ValueType & | centerValue
| ) |  |
| inlineinherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.

Parameters

  ijk | Index coordinates of stencil center
  centerValue | Value of the center element of the stencil

## ◆ moveTo() [3/4]

void moveTo | ( | const IterType & | iter | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Note
  This version is slightly faster than the one above, since the center voxel's value is read directly from the iterator.

## ◆ moveTo() [4/4]

void moveTo | ( | const Vec3< RealType > & | xyz | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Parameters

  xyz | Floating point voxel coordinates of stencil center

This method will check to see if it is necessary to update the stencil based on the cached index coordinates of the center point.

## ◆ pos()

unsigned int pos | ( |  | ) | const
| inline

Return linear offset for the specified stencil point relative to its center.

## ◆ principalCurvatures()

void principalCurvatures | ( | ValueType & | min,
|  | ValueType & | max
| ) |  | const
| inline

Computes the minimum and maximum principal curvature at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ setValue()

void setValue | ( | const ValueType & | value | ) |
| inlineinherited

Set the value at the specified location relative to the center of the stencil.

## ◆ size()

static int size | ( |  | ) |
| inlinestaticinherited

Return the size of the stencil buffer.

## Friends And Related Function Documentation

## ◆ BaseStencil

friend class BaseStencil
| friend

## Member Data Documentation

## ◆ mCenter

Coord mCenter
| protectedinherited

## ◆ mGrid

const GridType* mGrid
| protectedinherited

## ◆ SIZE

constexpr int SIZE = 19
| staticconstexpr